function [ p ] = fixedpoint( g, p0, Tol, Nmax )
% FIXEDPOINT Para determinar una solucin de la ecuacin p=g(p) dada
% una aproximacin inicial p0.
%
% Parmetros:
%    g: Funcin de la que se busca encontrar un punto fijo.
%   p0: Aproximacin inicial al punto fijo de g.
%  Tol: Error absoluto mnimo entre aproximaciones sucesivas.
% Nmax: Nmero mnimo de iteraciones a realizar antes de obtener una 
%       aproximacin menor o igual a Tol y fallar.
%
%    p: Solucin aproximada a un punto fijo de g o mensaje de error.

i = 1;

while(i <= Nmax)
    p = g(p0); 
    
    if(abs(p - p0) < Tol)
        return
    end
    
    i = i + 1;
    p0 = p;
end

error(['El mtodo fracas despus de %.d iteraciones. '...
       'Procedimiento terminado sin xito.'],Nmax);
end