function S = csfit_ejemplos(X,Y,dx0,dxn)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

 N=length(X)-1;

for i=1:N 
    H(i)=X(i+1)-X(i);
    D(i)=(Y(i+1)-Y(i))./H(i);
end

for j=1:N-1
    U(j)=6*(D(j+1)-D(j));
    A(j)=H(j+1);
    B(j)=2*(H(j)+H(j+1));
    C(j)=H(j+1);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Restricciones en los extremos para el spline sujeto%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    
%Parte del lado izquierdo de la 1ra ecuacion del sistema
%B(1)=B(1)-H(1)/2;
%Lado derecho de la 1ra ecuacion del sistema
%U(1)=U(1)-3*(D(1)-dx0);
%Parte del lado izquierdo de la ultima ecuacion del sistema
%B(N-1)=B(N-1)-H(N)/2;
%Lado derecho de la ultima ecuacion del sistema
%U(N-1)=U(N-1)-3*(dxn-D(N));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Restricciones en los extremos para el spline natural%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%B(1)= 2*(H(1)+H(2));
%U(1)=U(1);

%B(N-1) = 2*(H(N-1)+H(N));
%U(N-1)=U(N-1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Restricciones en los extremos para el spline cubico extrapolado%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% %Spline Extrapolado
 A(1)=H(2)-((H(1)*H(1))/H(2));
 C(N-2)=H(N-1)-((H(N)*H(N))/H(N-1));
 
 B(1)=(3*H(1))+(2*H(2))+((H(1)*H(1))/H(2));
 U(1)=U(1);
 
 B(N-1)=(2*H(N-1))+(3*H(N))+((H(N)*H(N))/H(N-1));
 U(N-1)=U(N-1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Restricciones en los extremos para el spline parabolico%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%B(1)= (3*H(1))+(2*H(2));
%U(1)=U(1);
 
%B(N-1) = (2*H(N-1))+(3*H(N));
%U(N-1)=U(N-1);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%Restricciones en los extremos para el spline con curvatura en los extremos%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%B(1)= 2*(H(1)+H(2));
%U(1)=U(1)-(H(1)*dx0);
 
%B(N-1) = 2*(H(N-1)+H(N));
%U(N-1)=U(N-1)-(H(N)*dxn);


for k=2:N-1
    temp=A(k-1)/B(k-1);
    B(k)=B(k)-temp*C(k-1);
    U(k)=U(k)-temp*U(k-1);
end


%%%%%%%%%%%%%%%%%%%%%%
%Solucion del sistema triangular superior, por Sustitucion Regresiva
%Algoritmo 3.1 - Mathews. Pag: 135
M(N)=U(N-1)/B(N-1);
for k=N-2:-1:1
    M(k+1)=(U(k)-C(k)*M(k+2))/B(k);
end
%%%%%%%%%%%%%%%%%%%%%%%



%Ecuaciones para m0 y mN

%Restricciones de Spline Sujeto
%M(1)=3*(D(1)-dx0)/H(1)-M(2)/2;
%M(N+1)=3*(dxn-D(N))/H(N)-M(N)/2;


%Restricciones de Spline Natural
%M(1)=0;
%M(N+1)=0;


%Restricciones de Spline Extrapolado
M(1)=M(2)-((H(1)*(M(3)-M(2)))/H(2));
M(N+1)=M(N)+((H(N)*(M(N)-M(N-1)))/H(N-1));


%Restricciones de Spline Parabolico
%M(1)= M(2);
%M(N+1)=M(N);

%Restricciones de Spline con Curvatura en los Extremos
%M(1)=dx0;
%M(N+1)=dxn;

for k=0:N-1
    S(k+1,1)=(M(k+2)-M(k+1))/(6*H(k+1));
    S(k+1,2)=M(k+1)/2;
    S(k+1,3)=D(k+1)-H(k+1)*(2*M(k+1)+M(k+2))/6;
    S(k+1,4)=Y(k+1);
end


cmap = hsv(N);  %# Creates a 6-by-3 set of colors from the HSV colormap

x = [];
y = [];
xlabel('X');
ylabel('Y');
for j=1:N
    hold on
    x = [x;X(j):.01:X(j+1)];
    y = [y;polyval(S(j,:),x(1,:)-X(j))];
    plot(x(1,:),y(1,:),X,Y,'*','Color',cmap(j,:));
    hold off
    x = [];
    y = [];
end



end
