function [ p ] = lagrange ( x, X, FX )
% LAGRANGE Para evaluar el polinomio interpolante P de los n + 1
% nmeros distintos x0,x1,...,xn en el valor x de la funcin f.
%
% Parmetros:
%   x: El punto donde se evaluar el polinomio.
%   X: Vector que contiene las abscisas en las que se conoce f.
%  FX: Vector con las ordenadas de f, correspondientes a los va-
%      lores del vector X.
%
%   p: El polinomio interpolante evaluado en x.

[~, n] = size(X);
p = 0;

for k=1:n
    l = 1;
    for i=1:n
        if(i ~= k)
            l = l * (x-X(i))/(X(k)-X(i));
        end
    end
    p = p+(FX(k)*l);
end
end